﻿param ( [Parameter(ValuefromPipeLinebyPropertyName=$true)]
 [Alias("Name")]
 [String]$ComputerName=$env:computername
 )
 begin {
 # Funktion, die das Ausgabeobjekt erstellt
 function getNewObject {
   param  ([String]$Computename,
   [System.Security.Cryptography.X509Certificates.X509Certificate]$cert
   )
   $obj = new-object -typeName PsObject -property @{
        computername = $Computername
        thumbprint = $NULL
        serialNumber = $NULL
        notbefore = $NULL
        notAfter   = $NULL
        subject    = $NULL
        issuer    = $NULL
        KeyUsage   = $NULL
        Domains    = $NULL
        hasPrivatekey = $false
        friendlyName = $NULL
        message = $NULL
        isvalid  = $false
        ExpiresInDays = 0
    }
    if ($cert) {
        $isValid = (($cert.NotBefore -le (get-date)) -and ((get-date) -le ($cert.NotAfter)))
        $ExpiresInDays = new-timespan (get-Date) $cert.notafter
        $obj.Thumbprint = $cert.Thumbprint
        $obj.notbefore  = $Cert.Notbefore
        $obj.notafter  = $Cert.Notafter
        $obj.subject   = $Cert.Subject
        $obj.issuer    = $cert.IssuerName.Name
        $obj.keyUsage  = [System.String]::join(",",$cert.enhancedKeyUsagelist)
        $obj.Domains  = [System.String]::join(",",$cert.DNSNameList)
        $obj.SerialNumber = $cert.SerialNumber
        $obj.friendlyName = $Cert.FriendlyName
        $obj.hasPrivatekey = $cert.hasPrivateKey
        $obj.IsValid = $isValid
        $obj.expiresinDays = $ExpiresInDays.Days
     }
     return $obj
 } # EOF GetNewObject
 #  Store und Name 
    [System.Security.Cryptography.X509Certificates.StoreName]$StoreName = 'My'
    [System.Security.Cryptography.X509Certificates.StoreLocation]$StoreLocation  = 'LocalMachine'
 } # EOF Begin
 process {
    try {
       $CertStore = new-object System.Security.Cryptography.X509Certificates.X509Store -ArgumentList "\\$($ComputerName)\$($StoreName)", $Storelocation
       $Flags = [System.Security.Cryptography.X509Certificates.OpenFlags]'ReadOnly'
       $CertStore.Open($Flags) | out-null
    } catch {
       $obj = getNewObject -computerName $Computername
       $obj.Message = $_.tostring() # fetch error
       return $obj
    }
    foreach ($certificate in $certStore.Certificates) {
       $obj = getNewObject -computername $Computername -cert $Certificate
       write-output $obj
    }
 } # end Process
 end {} 

 #.\Query-Certificate-Remote-Function.ps1 –Computername SRVSUBCA